KImageEffect class Reference (kdefx Library)

| # kdefx Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KImageEffect Class Reference

This class includes various QImage based graphical effects. More...

`#include <kimageeffect.h>`

List of all members.

## Public Types
enum | GradientType { VerticalGradient, HorizontalGradient, DiagonalGradient, CrossDiagonalGradient, PyramidGradient, RectangleGradient, PipeCrossGradient, EllipticGradient }
enum | RGBComponent { Red, Green, Blue, Gray, All }
enum | Lighting { NorthLite, NWLite, WestLite, SWLite, SouthLite, SELite, EastLite, NELite }
enum | ModulationType { Intensity, Saturation, HueShift, Contrast }
enum | NoiseType { UniformNoise = 0, GaussianNoise, MultiplicativeGaussianNoise, ImpulseNoise, LaplacianNoise, PoissonNoise }
enum | RotateDirection { Rotate90, Rotate180, Rotate270 }
## Static Public Member Functions
QImage | gradient (const QSize &size, const QColor &ca, const QColor &cb, GradientType type, int ncols=3)
| Create a gradient from color a to color b of the specified type.
QImage | unbalancedGradient (const QSize &size, const QColor &ca, const QColor &cb, GradientType type, int xfactor=100, int yfactor=100, int ncols=3)
| Create an unbalanced gradient.
QImage & | blend (const QColor &clr, QImage &dst, float opacity)
| Blends a color into the destination image, using an opacity value for blending one into another.
QImage & | blend (QImage &src, QImage &dst, float opacity)
| Blend the src image into the destination image, using an opacity value for blending one into another.
QImage & | blend (QImage &image, float initial_intensity, const QColor &bgnd, GradientType eff, bool anti_dir=false)
| Blend the provided image into a background of the indicated color.
QImage & | blend (QImage &image1, QImage &image2, GradientType gt, int xf=100, int yf=100)
| Blend an image into another one, using a gradient type for blending from one to another.
QImage & | blend (QImage &image1, QImage &image2, QImage &blendImage, RGBComponent channel)
| Blend an image into another one, using a color channel of a third image for the decision of blending from one to another.
bool | blend (const QImage &upper, const QImage &lower, QImage &output)
| Blend an image into another one, using alpha in the expected way.
bool | blend (int &x, int &y, const QImage &upper, const QImage &lower, QImage &output)
| Blend an image into another one, using alpha in the expected way and over coordinates `x` and `y` with respect to the lower image.
bool | blendOnLower (int x, int y, const QImage &upper, const QImage &lower)
| Blend an image into another one, using alpha in the expected way and over coordinates `x` and `y` with respect to the lower image.
QImage & | channelIntensity (QImage &image, float percent, RGBComponent channel)
| Modifies the intensity of a pixmap's RGB channel component.
QImage & | fade (QImage &img, float val, const QColor &color)
| Fade an image to a certain background color.
QImage & | flatten (QImage &image, const QColor &ca, const QColor &cb, int ncols=0)
| This recolors a pixmap.
QImage & | hash (QImage &image, Lighting lite=NorthLite, unsigned int spacing=0)
| Build a hash on any given QImage.
QImage & | intensity (QImage &image, float percent)
| Either brighten or dim the image by a specified percent.
QImage & | modulate (QImage &image, QImage &modImage, bool reverse, ModulationType type, int factor, RGBComponent channel)
| Modulate the image with a color channel of another image.
QImage & | toGray (QImage &image, bool fast=false)
| Convert an image to grayscale.
QImage & | desaturate (QImage &image, float desat=0.3)
| Desaturate an image evenly.
QImage & | contrast (QImage &image, int c)
| Fast, but low quality contrast of an image.
QImage & | dither (QImage &img, const QColor *palette, int size)
| Dither an image using Floyd-Steinberg dithering for low-color situations.
QImage & | selectedImage (QImage &img, const QColor &col)
| Calculate the image for a selected image, for instance a selected icon on the desktop.
void | contrastHSV (QImage &img, bool sharpen=true)
| High quality, expensive HSV contrast.
void | normalize (QImage &img)
| Normalizes the pixel values to span the full range of color values.
void | equalize (QImage &img)
| Performs histogram equalization on the reference image.
void | threshold (QImage &img, unsigned int value=128)
| Thresholds the reference image.
void | solarize (QImage &img, double factor=50.0)
| Produces a 'solarization' effect seen when exposing a photographic film to light during the development process.
QImage | emboss (QImage &src)
| Embosses the source image.
QImage | despeckle (QImage &src)
| Minimizes speckle noise in the source image using the 8 hull algorithm.
QImage | charcoal (QImage &src, double factor=50.0)
| Produces a neat little "charcoal" effect.
QImage | rotate (QImage &src, RotateDirection r)
| Rotates the image by the specified amount.
QImage | sample (QImage &src, int w, int h)
| Scales an image using simple pixel sampling.
QImage | addNoise (QImage &src, NoiseType type=GaussianNoise)
| Adds noise to an image.
QImage | blur (QImage &src, double factor=50.0)
| Blurs an image by convolving pixel neighborhoods.
QImage | edge (QImage &src, double factor=50.0)
| Detects edges in an image using pixel neighborhoods and an edge detection mask.
QImage | implode (QImage &src, double factor=30.0, unsigned int background=0xFFFFFFFF)
| Implodes an image by a specified percent.
QImage | oilPaint (QImage &src, int radius=3)
| Produces an oil painting effect.
QImage | sharpen (QImage &src, double factor=30.0)
| Sharpens the pixels in the image using pixel neighborhoods.
QImage | spread (QImage &src, unsigned int amount=3)
| Randomly displaces pixels.
QImage | shade (QImage &src, bool color_shading=true, double azimuth=30.0, double elevation=30.0)
| Shades the image using a distance light source.
QImage | swirl (QImage &src, double degrees=50.0, unsigned int background=0xFFFFFFFF)
| Swirls the image by a specified amount.
QImage | wave (QImage &src, double amplitude=25.0, double frequency=150.0, unsigned int background=0xFFFFFFFF)
| Modifies the pixels along a sine wave.

## Detailed Description

This class includes various QImage based graphical effects.

Everything is static, so there is no need to create an instance of this class. You can just call the static methods. They are encapsulated here merely to provide a common namespace.

Definition at line 47 of file kimageeffect.h.

## Member Function Documentation

QImage KImageEffect::gradient | ( | const QSize & | size,
|  | const QColor & | ca,
|  | const QColor & | cb,
|  | GradientType | type,
|  | int | ncols = 3
| ) | `[static]`

  | Create a gradient from color a to color b of the specified type. Parameters:
  size | The desired size of the gradient.
  ca | Color a
  cb | Color b
  type | The type of gradient.
  ncols | The number of colors to use when not running on a truecolor display. The gradient will be dithered to this number of colors. Pass 0 to prevent dithering.
Definition at line 58 of file kimageeffect.cpp. References QColor::blue(), QPixmap::defaultDepth(), dither(), QColor::green(), QSize::height(), QColor::red(), QImage::scanLine(), QColor::setRgb(), and QSize::width(). Referenced by KPixmapEffect::gradient().

QImage KImageEffect::unbalancedGradient | ( | const QSize & | size,
|  | const QColor & | ca,
|  | const QColor & | cb,
|  | GradientType | type,
|  | int | xfactor = 100,
|  | int | yfactor = 100,
|  | int | ncols = 3
| ) | `[static]`

  | Create an unbalanced gradient. An unbalanced gradient is a gradient where the transition from color a to color b is not linear, but in this case, exponential. Parameters:
  size | The desired size of the gradient.
  ca | Color a
  cb | Color b
  type | The type of gradient.
  xfactor | The x decay length. Use a value between -200 and 200.
  yfactor | The y decay length.
  ncols | The number of colors. See KPixmapEffect:gradient.
Definition at line 322 of file kimageeffect.cpp. References QColor::blue(), QPixmap::defaultDepth(), dither(), QColor::green(), QSize::height(), QColor::red(), QColor::rgb(), QImage::scanLine(), QColor::setRgb(), and QSize::width(). Referenced by blend(), and KPixmapEffect::unbalancedGradient().

QImage & KImageEffect::blend | ( | const QColor & | clr,
|  | QImage & | dst,
|  | float | opacity
| ) | `[static]`

  | Blends a color into the destination image, using an opacity value for blending one into another. Very fast direct pixel manipulation is used. Author: Karol Szwed (gallium@kde.org) Parameters:
  clr | source color to be blended into the destination image.
  dst | destination image in which the source will be blended into.
  opacity | opacity (in percent) which determines how much the source color will be blended into the destination image.
Returns: The destination image (dst) containing the result. Definition at line 860 of file kimageeffect.cpp. References QImage::bits(), QImage::convertDepth(), QImage::depth(), QImage::height(), QColor::rgb(), and QImage::width(). Referenced by KPixmapEffect::blend(), blend(), and selectedImage().

QImage & KImageEffect::blend | ( | QImage & | src,
|  | QImage & | dst,
|  | float | opacity
| ) | `[static]`

  | Blend the src image into the destination image, using an opacity value for blending one into another. Very fast direct pixel manipulation is used. Author: Karol Szwed (gallium@kde.org) Parameters:
  src | source image to be blended into the destination image.
  dst | destination image in which the source will be blended into.
  opacity | opacity (in percent) which determines how much the source image will be blended into the destination image.
Returns: The destination image (dst) containing the result. Definition at line 903 of file kimageeffect.cpp. References QImage::bits(), QImage::convertDepth(), QImage::depth(), QImage::height(), and QImage::width().

QImage & KImageEffect::blend | ( | QImage & | image,
|  | float | initial_intensity,
|  | const QColor & | bgnd,
|  | GradientType | eff,
|  | bool | anti_dir = false
| ) | `[static]`

  | Blend the provided image into a background of the indicated color. Parameters:
  initial_intensity | this parameter takes values from -1 to 1: a) if positive: how much to fade the image in its less affected spot b) if negative: roughly indicates how much of the image remains unaffected
  bgnd | indicates the color of the background to blend in
  eff | lets you choose what kind of blending you like
  anti_dir | blend in the opposite direction (makes no much sense with concentric blending effects)
  image | must be 32bpp
Definition at line 955 of file kimageeffect.cpp. References QImage::bits(), QColor::blue(), QImage::depth(), QColor::green(), QImage::height(), intensity(), QColor::red(), and QImage::width().

QImage & KImageEffect::blend | ( | QImage & | image1,
|  | QImage & | image2,
|  | GradientType | gt,
|  | int | xf = 100,
|  | int | yf = 100
| ) | `[static]`

  | Blend an image into another one, using a gradient type for blending from one to another. Parameters:
  image1 | source1 and result of blending
  image2 | source2 of blending
  gt | gradient type for blending between source1 and source2
  xf | x decay length for unbalanced gradient tpye
  yf | y decay length for unbalanced gradient tpye
Definition at line 1163 of file kimageeffect.cpp. References blend(), QImage::height(), QImage::size(), unbalancedGradient(), and QImage::width().

QImage & KImageEffect::blend | ( | QImage & | image1,
|  | QImage & | image2,
|  | QImage & | blendImage,
|  | RGBComponent | channel
| ) | `[static]`

  | Blend an image into another one, using a color channel of a third image for the decision of blending from one to another. Parameters:
  image1 | Source 1 and result of blending
  image2 | Source 2 of blending
  blendImage | If the gray value of of pixel is 0, the result for this pixel is that of image1; for a gray value of 1, the pixel of image2 is used; for a value inbetween, a corresponding blending is used.
  channel | The RBG channel to use for the blending decision.
Definition at line 1181 of file kimageeffect.cpp. References QImage::bits(), QImage::colorTable(), QImage::convertDepth(), QImage::depth(), QImage::height(), and QImage::width().

bool KImageEffect::blend | ( | const QImage & | upper,
|  | const QImage & | lower,
|  | QImage & | output
| ) | `[static]`

| Blend an image into another one, using alpha in the expected way. Author: Rik Hemsley (rikkus) <rik@kde.org> Definition at line 1784 of file kimageeffect.cpp. References QImage::copy(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

bool KImageEffect::blend | ( | int & | x,
|  | int & | y,
|  | const QImage & | upper,
|  | const QImage & | lower,
|  | QImage & | output
| ) | `[static]`

| Blend an image into another one, using alpha in the expected way and over coordinates `x` and `y` with respect to the lower image. The output is a QImage which is the `upper` image already blended with the `lower` one, so its size will be (in general) the same than `upper` instead of the same size than `lower` like the method above. In fact, the size of `output` is like upper's one only when it can be painted on lower, if there has to be some clipping, output's size will be the clipped area and x and y will be set to the correct up-left corner where the clipped rectangle begins. Definition at line 1856 of file kimageeffect.cpp. References QImage::create(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

bool KImageEffect::blendOnLower | ( | int | x,
|  | int | y,
|  | const QImage & | upper,
|  | const QImage & | lower
| ) | `[static]`

| Blend an image into another one, using alpha in the expected way and over coordinates `x` and `y` with respect to the lower image. The output is painted in the own `lower` image. This is an optimization of the blend method above provided by convenience. Definition at line 1920 of file kimageeffect.cpp. References QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage & KImageEffect::channelIntensity | ( | QImage & | image,
|  | float | percent,
|  | RGBComponent | channel
| ) | `[static]`

  | Modifies the intensity of a pixmap's RGB channel component. Author: Daniel M. Duley (mosfet) Parameters:
  image | The QImage to process.
  percent | Percent value. Use a negative value to dim.
  channel | Which channel(s) should be modified
Returns: The `image`, provided for convenience. Definition at line 639 of file kimageeffect.cpp. References QImage::bits(), QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), and QImage::width(). Referenced by KPixmapEffect::channelIntensity().

QImage & KImageEffect::fade | ( | QImage & | img,
|  | float | val,
|  | const QColor & | color
| ) | `[static]`

  | Fade an image to a certain background color. The number of colors will not be changed. Parameters:
  image | The QImage to process.
  val | The strength of the effect. 0 <= val <= 1.
  color | The background color.
Returns: Returns the image(), provided for convenience. Definition at line 1462 of file kimageeffect.cpp. References QColor::blue(), QImage::color(), QImage::depth(), QColor::green(), QImage::height(), QImage::numColors(), QColor::red(), QImage::scanLine(), QImage::setColor(), and QImage::width(). Referenced by KPixmapEffect::fade().

QImage & KImageEffect::flatten | ( | QImage & | image,
|  | const QColor & | ca,
|  | const QColor & | cb,
|  | int | ncols = 0
| ) | `[static]`

  | This recolors a pixmap. The most dark color will become color a, the most bright one color b, and in between. Parameters:
  image | A QImage to process.
  ca | Color a
  cb | Color b
Definition at line 1365 of file kimageeffect.cpp. References QColor::blue(), QImage::color(), QImage::depth(), dither(), QColor::green(), QImage::height(), QImage::numColors(), QImage::pixel(), QColor::red(), QColor::rgb(), QImage::setColor(), QImage::setPixel(), and QImage::width(). Referenced by KPixmapEffect::pattern().

QImage & KImageEffect::hash | ( | QImage & | image,
|  | Lighting | lite = NorthLite,
|  | unsigned int | spacing = 0
| ) | `[static]`

  | Build a hash on any given QImage. Parameters:
  image | The QImage to process
  lite | The hash faces the indicated lighting (cardinal poles).
  spacing | How many unmodified pixels inbetween hashes.
Returns: Returns the image(), provided for convenience. Definition at line 1284 of file kimageeffect.cpp. References QImage::bits(), QImage::height(), and QImage::width(). Referenced by KPixmapEffect::hash().

QImage & KImageEffect::intensity | ( | QImage & | image,
|  | float | percent
| ) | `[static]`

  | Either brighten or dim the image by a specified percent. For example, .50 will modify the colors by 50%. Author: Daniel M. Duley (mosfet) Parameters:
  image | The QImage to process.
  percent | The percent value. Use a negative value to dim.
Returns: Returns The image(), provided for convenience. Definition at line 573 of file kimageeffect.cpp. References QImage::bits(), QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), and QImage::width(). Referenced by blend(), and KPixmapEffect::intensity().

QImage & KImageEffect::modulate | ( | QImage & | image,
|  | QImage & | modImage,
|  | bool | reverse,
|  | ModulationType | type,
|  | int | factor,
|  | RGBComponent | channel
| ) | `[static]`

  | Modulate the image with a color channel of another image. Parameters:
  image | The QImage to modulate and result.
  modImage | The QImage to use for modulation.
  reverse | Invert the meaning of image/modImage; result is image!
  type | The modulation Type to use.
  factor | The modulation amplitude; with 0 no effect [-200;200].
  channel | The RBG channel of image2 to use for modulation.
Returns: Returns the image(), provided for convenience. Definition at line 730 of file kimageeffect.cpp. References QImage::colorTable(), QImage::convertDepth(), QImage::depth(), QImage::height(), QColor::rgb(), QImage::scanLine(), QColor::setHsv(), QColor::setRgb(), and QImage::width().

QImage & KImageEffect::toGray | ( | QImage & | image,
|  | bool | fast = false
| ) | `[static]`

  | Convert an image to grayscale. Author: Daniel M. Duley (mosfet) Parameters:
  image | The QImage to process.
  fast | Set to `true` in order to use a faster but non-photographic quality algorithm. Appropriate for things such as toolbar icons.
Returns: Returns the image(), provided for convenience. Definition at line 1544 of file kimageeffect.cpp. References QImage::bits(), QImage::color(), QImage::colorTable(), QImage::depth(), KStdAccel::end(), QImage::height(), QImage::numBytes(), QImage::numColors(), QImage::setColor(), and QImage::width(). Referenced by charcoal(), emboss(), and KPixmapEffect::toGray().

QImage & KImageEffect::desaturate | ( | QImage & | image,
|  | float | desat = 0.3
| ) | `[static]`

  | Desaturate an image evenly. Parameters:
  image | The QImage to process.
  desat | A value between 0 and 1 setting the degree of desaturation
Returns: Returns the image(), provided for convenience. Definition at line 1594 of file kimageeffect.cpp. References QImage::bits(), QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), QColor::rgb(), QColor::setHsv(), QColor::setRgb(), and QImage::width(). Referenced by KPixmapEffect::desaturate().

QImage & KImageEffect::contrast | ( | QImage & | image,
|  | int | c
| ) | `[static]`

  | Fast, but low quality contrast of an image. Also see contrastHSV. Author: Daniel M. Duley (mosfet) Parameters:
  image | The QImage to process.
  c | A contrast value between -255 to 255.
Returns: The image(), provided for convenience. Definition at line 1617 of file kimageeffect.cpp. References QImage::bits(), QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), and QImage::width(). Referenced by KPixmapEffect::contrast().

QImage & KImageEffect::dither | ( | QImage & | img,
|  | const QColor * | palette,
|  | int | size
| ) | `[static]`

  | Dither an image using Floyd-Steinberg dithering for low-color situations. Parameters:
  image | The QImage to process.
  palette | The color palette to use
  size | The size of the palette
Returns: Returns the image(), provided for convenience. Definition at line 1667 of file kimageeffect.cpp. References QColor::blue(), QImage::depth(), QColor::green(), QImage::height(), QColor::red(), QImage::scanLine(), QImage::setColor(), QImage::setNumColors(), and QImage::width(). Referenced by KPixmapEffect::blend(), KPixmapEffect::dither(), flatten(), gradient(), KPixmapEffect::hash(), and unbalancedGradient().

QImage & KImageEffect::selectedImage | ( | QImage & | img,
|  | const QColor & | col
| ) | `[static]`

  | Calculate the image for a selected image, for instance a selected icon on the desktop. Parameters:
  img | the QImage to select
  col | the selected color, usually from QColorGroup::highlight().
Definition at line 1991 of file kimageeffect.cpp. References blend(). Referenced by KPixmapEffect::selectedPixmap().

void KImageEffect::contrastHSV | ( | QImage & | img,
|  | bool | sharpen = true
| ) | `[static]`

  | High quality, expensive HSV contrast. You can do a faster one by just taking a intensity threshold (ie: 128) and incrementing RGB color channels above it and decrementing those below it, but this gives much better results. Author: Daniel M. Duley (mosfet) Parameters:
  img | The QImage to process.
  sharpen | If true sharpness is increase, (spiffed). Otherwise it is decreased, (dulled).
Definition at line 3756 of file kimageeffect.cpp. References QImage::bits(), QColor::blue(), QImage::colorTable(), QImage::depth(), QColor::green(), QImage::height(), QImage::numColors(), QColor::red(), QColor::setHsv(), QColor::setRgb(), and QImage::width().

void KImageEffect::normalize | ( | QImage & | img | ) | `[static]`

| Normalizes the pixel values to span the full range of color values. This is a contrast enhancement technique. Author: Daniel M. Duley (mosfet) Definition at line 2003 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), QImage::scanLine(), and QImage::width(). Referenced by charcoal(), and emboss().

void KImageEffect::equalize | ( | QImage & | img | ) | `[static]`

| Performs histogram equalization on the reference image. Author: Daniel M. Duley (mosfet) Definition at line 2119 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), QImage::scanLine(), and QImage::width().

void KImageEffect::threshold | ( | QImage & | img,
|  | unsigned int | value = 128
| ) | `[static]`

  | Thresholds the reference image. You can also threshold images by using ThresholdDither in the various QPixmap/QImage convert methods, but this lets you specify a threshold value. Author: Daniel M. Duley (mosfet) Parameters:
  img | The QImage to process.
  value | The threshold value.
Definition at line 2297 of file kimageeffect.cpp. References QImage::bits(), QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), and QImage::width(). Referenced by solarize().

void KImageEffect::solarize | ( | QImage & | img,
|  | double | factor = 50.0
| ) | `[static]`

  | Produces a 'solarization' effect seen when exposing a photographic film to light during the development process. Author: Daniel M. Duley (mosfet) Parameters:
  img | The QImage to process.
  factor | The extent of the solarization (0-99.9)
Definition at line 2920 of file kimageeffect.cpp. References QImage::bits(), QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), threshold(), and QImage::width().

QImage KImageEffect::emboss | ( | QImage & | src | ) | `[static]`

  | Embosses the source image. This involves highlighting the edges and applying various other enhancements in order to get a metal effect. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
Returns: The embossed image. The original is not changed. Definition at line 3422 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), normalize(), QImage::scanLine(), toGray(), and QImage::width().

QImage KImageEffect::despeckle | ( | QImage & | src | ) | `[static]`

  | Minimizes speckle noise in the source image using the 8 hull algorithm. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
Returns: The despeckled image. The original is not changed. Definition at line 2405 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage KImageEffect::charcoal | ( | QImage & | src,
|  | double | factor = 50.0
| ) | `[static]`

  | Produces a neat little "charcoal" effect. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  factor | The factor for detecting lines (0-99.0).
Returns: The charcoal image. The original is not changed. Definition at line 2313 of file kimageeffect.cpp. References blur(), QImage::detach(), edge(), QImage::invertPixels(), normalize(), and toGray().

QImage KImageEffect::rotate | ( | QImage & | src,
|  | RotateDirection | r
| ) | `[static]`

  | Rotates the image by the specified amount. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  r | The rotate direction.
Returns: The rotated image. The original is not changed. Definition at line 2822 of file kimageeffect.cpp. References QImage::colorTable(), QImage::create(), QImage::depth(), QImage::height(), QImage::numColors(), QImage::scanLine(), QImage::setNumColors(), and QImage::width().

QImage KImageEffect::sample | ( | QImage & | src,
|  | int | w,
|  | int | h
| ) | `[static]`

  | Scales an image using simple pixel sampling. This does not produce nearly as nice a result as QImage::smoothScale(), but has the advantage of being much faster - only a few milliseconds. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  w | The new width.
  h | The new height.
Returns: The scaled image. The original is not changed. Definition at line 2204 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::numColors(), QImage::scanLine(), QImage::setNumColors(), and QImage::width().

QImage KImageEffect::addNoise | ( | QImage & | src,
|  | NoiseType | type = GaussianNoise
| ) | `[static]`

  | Adds noise to an image. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  type | The algorithm used to generate the noise.
Returns: The image with noise added. The original is not changed. Definition at line 2611 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage KImageEffect::blur | ( | QImage & | src,
|  | double | factor = 50.0
| ) | `[static]`

  | Blurs an image by convolving pixel neighborhoods. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  factor | The percent weight to give to the center pixel.
Returns: The blurred image. The original is not changed. Definition at line 3654 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width(). Referenced by charcoal().

QImage KImageEffect::edge | ( | QImage & | src,
|  | double | factor = 50.0
| ) | `[static]`

  | Detects edges in an image using pixel neighborhoods and an edge detection mask. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  factor | The percent weight to give to the center pixel.
Returns: The image with edges detected. The original is not changed. Definition at line 3174 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width(). Referenced by charcoal().

QImage KImageEffect::implode | ( | QImage & | src,
|  | double | factor = 30.0,
|  | unsigned int | background = 0xFFFFFFFF
| ) | `[static]`

  | Implodes an image by a specified percent. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  factor | The extent of the implosion.
  background | An RGBA value to use for the background. After the effect some pixels may be "empty". This value is used for those pixels.
Returns: The imploded image. The original is not changed. Definition at line 2741 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage KImageEffect::oilPaint | ( | QImage & | src,
|  | int | radius = 3
| ) | `[static]`

  | Produces an oil painting effect. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  radius | The radius of the pixel neighborhood used in applying the effect.
Returns: The new image. The original is not changed. Definition at line 3098 of file kimageeffect.cpp. References QImage::depth(), QImage::detach(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage KImageEffect::sharpen | ( | QImage & | src,
|  | double | factor = 30.0
| ) | `[static]`

  | Sharpens the pixels in the image using pixel neighborhoods. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  factor | The percent weight to give to the center pixel.
Returns: The sharpened image. The original is not changed. Definition at line 3271 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage KImageEffect::spread | ( | QImage & | src,
|  | unsigned int | amount = 3
| ) | `[static]`

  | Randomly displaces pixels. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  amount | The vicinity for choosing a random pixel to swap.
Returns: The image with pixels displaced. The original is not changed. Definition at line 2943 of file kimageeffect.cpp. References QImage::depth(), QImage::detach(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage KImageEffect::shade | ( | QImage & | src,
|  | bool | color_shading = true,
|  | double | azimuth = 30.0,
|  | double | elevation = 30.0
| ) | `[static]`

  | Shades the image using a distance light source. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  color_shading | If true do color shading, otherwise do grayscale.
  azimuth | Determines the light source and direction.
  elevation | Determines the light source and direction.
Returns: The shaded image. The original is not changed. Definition at line 3520 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), shade(), and QImage::width(). Referenced by shade().

QImage KImageEffect::swirl | ( | QImage & | src,
|  | double | degrees = 50.0,
|  | unsigned int | background = 0xFFFFFFFF
| ) | `[static]`

  | Swirls the image by a specified amount. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  degrees | The tightness of the swirl.
  background | An RGBA value to use for the background. After the effect some pixels may be "empty". This value is used for those pixels.
Returns: The swirled image. The original is not changed. Definition at line 2994 of file kimageeffect.cpp. References QImage::colorTable(), QImage::depth(), QImage::height(), QImage::scanLine(), and QImage::width().

QImage KImageEffect::wave | ( | QImage & | src,
|  | double | amplitude = 25.0,
|  | double | frequency = 150.0,
|  | unsigned int | background = 0xFFFFFFFF
| ) | `[static]`

  | Modifies the pixels along a sine wave. Author: Daniel M. Duley (mosfet) Parameters:
  src | The QImage to process.
  amplitude | The amplitude of the sine wave.
  wavelength | The frequency of the sine wave.
Returns: The new image. The original is not changed. Definition at line 3072 of file kimageeffect.cpp. References QImage::height(), QImage::scanLine(), and QImage::width().

The documentation for this class was generated from the following files:

- kimageeffect.h
- kimageeffect.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 12:44:31 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001